#!/usr/bin/sh
#
# Licensed under the terms of the GNU GPL License version 2

source ../../utils/root-check.sh

# Temporarily skip this test until we get more time to look at it.

exit 3

check_root
is_root=$?
if [ "$is_root" -ne "0" ]; then
	exit 3
fi

# Build
cd libhugetlbfs
make BUILDTYPE=NATIVEONLY > /dev/null 2>/dev/null
if [ "$?" -ne "0" ]; then
	echo "Could not build libhugetlbfs tests"
	exit -1
fi

# Setup: Need at least 32 free hugepages for the shm test to run
obj/hugeadm --pool-pages-min 2MB:32

# Run
make BUILDTYPE=NATIVEONLY func > ../libhugetlbfs_results.tmp
if [ "$?" -ne "0" ]; then
	echo "Could not run tests"
	exit -1
fi

# look at stuff
# TODO
# Remove the readahead test.  It seems it's known to always fail.
sed -e 's/readahead_reserve.sh .*//' ../libhugetlbfs_results.tmp > ../libhugetlbfs_results.tmp2

# Filter out the morecore tests too.  Question sent into the list about those
sed -e 's/HUGETLB_MORECORE=.*//' ../libhugetlbfs_results.tmp2 > ../libhugetlbfs_results.txt

grep -v "FAIL:" ../libhugetlbfs_results.txt | grep "FAIL"
if [ "$?" == "0" ]; then
	echo "Test failures"
	exit -1
fi

# Cleanup
obj/hugeadm --pool-pages-min 2MB:0
obj/hugeadm --pool-pages-max 2MB:0

make clean > /dev/null 2> /dev/null
cd ..
rm -rf libhugetlbfs_results.*
